SystemOrganization addCategory: #Pharobot!

TransformationMorph subclass: #Robot
	instanceVariableNames: 'mundo direccion estado_pincelArriba estado_pincelAbajo estado_pincelActual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!Robot class methodsFor: 'crear instancia' stamp: 'MorellatoAriel 2/28/2012 00:03'!
"Luego de crear un robot hay que mandarle el mensaje 'inicializarRobot' "

crearRobot: unMundo

|nuevoRobot|

nuevoRobot:= self new.
nuevoRobot mundo: unMundo.
^ nuevoRobot openInWorld .
! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
direccion
	^ direccion! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
direccion: anObject
	direccion := anObject! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelAbajo
	^ estado_pincelAbajo! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelAbajo: anObject
	estado_pincelAbajo := anObject! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelActual
	^ estado_pincelActual! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelActual: anObject
	estado_pincelActual := anObject! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelArriba
	^ estado_pincelArriba! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelArriba: anObject
	estado_pincelArriba := anObject! !

!Robot methodsFor: 'inicializar' stamp: 'MorellatoAriel 2/28/2012 00:04'!
inicializarRobot

"Se une el robot con su mundo"
self mundo addMorph: self.


! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
mundo
	^ mundo! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
mundo: anObject
	mundo := anObject! !

Morph subclass: #Mundo
	instanceVariableNames: 'robot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!Mundo class methodsFor: 'crear instancia' stamp: 'MorellatoAriel 2/27/2012 23:50'!
"El tamao es pasado de la siguiente manera    140 @ 140 donde los valores de X e Y deben ser multiplos de 70"

crearMundo: unaSuperficie

|mundo nroRepeticionesEnX nroRepeticionesEnY posicionActual cuadriculaNueva|

"Chequear datos ingresados"

((unaSuperficie x isDivisibleBy: 70) & (unaSuperficie y isDivisibleBy: 70))
ifFalse: [ self error: 'Los valores ingresados deben ser multiplos de 70'].

mundo:= self new.
mundo color: (Color black alpha: 0.3).
mundo extent: unaSuperficie.

"Cuadriculado"

nroRepeticionesEnX:= mundo extent x // 70.
nroRepeticionesEnY:= mundo extent y // 70.
posicionActual:= mundo position.

(nroRepeticionesEnY) timesRepeat: 
[(nroRepeticionesEnX) timesRepeat: [ cuadriculaNueva:= CuadriculaDeMundo crearCuadriculaDeMundo.	
								cuadriculaNueva position: posicionActual.
								mundo addMorph: cuadriculaNueva.
								posicionActual:= (posicionActual x + 70) @ (posicionActual y)].
							
	posicionActual:= (posicionActual x - (nroRepeticionesEnX * 70) @ (posicionActual y + 70)) ].

^ mundo openInWorld .! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/27/2012 23:53'!
extenderAlEste: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x + (cuadriculasAExtender * 70)) @ (self extent y ).
nuevoMundo position: self position.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/27/2012 23:39'!
extenderAlNorte: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x) @ (self extent y + (cuadriculasAExtender * 70)).
nuevoMundo position: (self position x) @ (self position y - (cuadriculasAExtender * 70)).
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/27/2012 23:57'!
extenderAlOeste: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x + (cuadriculasAExtender * 70)) @ (self extent y ).
nuevoMundo position: (self position x - (cuadriculasAExtender * 70) @ (self position y)).
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/27/2012 23:52'!
extenderAlSur: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x) @ (self extent y + (cuadriculasAExtender * 70)).
nuevoMundo position: self position.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:32'!
robot
	^ robot! !

!Mundo methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:32'!
robot: anObject
	robot := anObject! !

BorderedMorph subclass: #CuadriculaDeMundo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!CuadriculaDeMundo class methodsFor: 'crear instancia' stamp: 'MorellatoAriel 2/27/2012 22:52'!
crearCuadriculaDeMundo

|cuadricula|
cuadricula:= BorderedMorph new.
cuadricula extent: 70@70.
cuadricula color: (Color black alpha: 0).
^ cuadricula openInWorld .! !
